Bug 467280 - "df" returns bogus size on very large CIFS VFS filesystem
"df" returns bogus size on very large CIFS VFS filesystem
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
8
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Scott Ingram
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-16 13:01 EDT by Scott Ingram
Modified: 2009-01-09 02:53 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-09 02:53:34 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
tcpdump of df failing on cifs (5.34 KB, application/octet-stream)
2008-10-16 13:01 EDT, Scott Ingram
no flags Details
tcpdump of df working on cifs (4.42 KB, application/octet-stream)
2008-10-16 13:05 EDT, Scott Ingram
no flags Details

  None (edit)
Description Scott Ingram 2008-10-16 13:01:30 EDT
Created attachment 320578 [details]
tcpdump of df failing on cifs 

Description of problem:  "df" utility reports an indeterminate value on a very large (~92TB) CIFS filesystem in FC releases later than 3.  CIFS client module never sends a "file system size" request to the server when df is invoked, instead generating an "Unknown 0x201" SMB FS INFO request.

Version-Release number of selected component (if applicable):

Working versions:
FC3 2.6.9-1.667smp CIFS VFS v. 1.20 & df --version 5.2.1
Debian 2.8.18-686 CIFS VFS v 1.45 & df --version 5.97

Nonworking versions:
FC5 2.6.15-1.2054_FC5smp CIFS VFS v 1.40 & df --version 5.93
FC7 2.6.23.17-88.fc7 SMP CIFS VFS v 1.50
FC8 2.6.23.1-42.fc8 CIFS VFS v 1.50 & df --version 6.9

How reproducible:
Always fails on affected systems.  CIFS filesystem server is Samba 3.0.24-Isilon OneFS v4.7.8.16.

Steps to Reproduce:
1.  mount -t cifs //isilon-server /media/Isilon
2.  df -v /mnt
3.  umount /mnt
  
Actual results:

FC7 df output:

Filesystem           1K-blocks      Used Available Use% Mounted on
//isc2.pa.creativestorage.tnsmi-cmr.com/asdata
                     17179869176 7915041216 9264827960  47% /media/Isilon

Expected results:

FC3 version 5.2.1 df output:

Filesystem           1K-blocks      Used Available Use% Mounted on
//isc2.pa.creativestorage.tnsmi-cmr.com/asdata
                     92781648384 83516912480 9264735904  91% /media/Isilon


Additional info:
Network traffic dump transaction attached.  Minor SMB protocol difference between working FC3 and failing FC7 machine. FC3 "Dialect Index: 0, greater than LANMAN2.1", FC7 negotiates "Dialect Index: 2, greater than LANMAN2.1".
Comment 1 Scott Ingram 2008-10-16 13:05:44 EDT
Created attachment 320580 [details]
tcpdump of df working on cifs
Comment 2 Simo Sorce 2008-10-16 13:18:28 EDT
cifs.ko is a kernel component, reassigning.
Comment 3 Jeff Layton 2008-10-20 14:11:28 EDT
Could you send along a capture between the FC7 box and the server? I need to compare the two.
Comment 4 Jeff Layton 2008-10-20 14:13:03 EDT
Ahh nm -- I didn't see the first  capture...
Comment 5 Jeff Layton 2008-10-20 14:40:37 EDT
Ok, the 0x201 is a legit infolevel when talking to a server with posix extensions:

#define SMB_QUERY_POSIX_FS_INFO     0x201

...unfortunately, since wireshark doesn't understand it, we'll have to decode the data in the failure capture by hand. That'll take a while, so I'll have a closer look when I can.
Comment 6 Scott Ingram 2008-10-20 15:27:23 EDT
Okay, I see the define in cifspdu.h.  I'd be happy to work on decoding the exchange if I had some clue where to start.
Comment 7 Jeff Layton 2008-10-20 17:07:07 EDT
This is a decent reference (I think) for the format on the wire:

http://wiki.samba.org/index.php/UNIX_Extensions#SMB_QUERY_POSIX_FS_INFO

The kernel function that parses this is:

CIFSSMBQFSPosixInfo()

CIFS code can look a little hairy though...

Mostly, I'm interested in whether the server is sending us the right info. We want to know whether this is a client or server problem.

For bonus points, it would be nice if wireshark could decode these packets ;)
Comment 8 Scott Ingram 2008-11-05 10:58:34 EST
Upon further investigation, this turns out to be a server side issue.

The server platform affected is Samba 3.0.24 on an Isilon OneFS v4.7.8.16 platform.  Since our Isilon systems are supported by Isilon, we also approached them with the issue, and quoted from their response: "This does appear to be a issue with linux clients and releases of OneFS in the latter 4.7.x series. I have confirmed that this is resolved in our 5.0.x series..."

I would would like to wait a bit to close this bug, because I haven't had a chance yet to review the wireshark stuff to see if I can get it to decode the packets that would have identified the problem more precisely.
Comment 9 Jeff Layton 2008-11-05 11:05:45 EST
Thanks for the info. Since it does look like a server side issue, I'll go ahead and reassign this to you. Better wireshark decoders are always a welcome addition...
Comment 10 Bug Zapper 2008-11-26 06:14:43 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Bug Zapper 2009-01-09 02:53:34 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.